// CheapMocap.cpp: dfinit le point d'entre pour l'application console.

//Include files
#include "stdafx.h"
#include "cv.h"
#include "highgui.h"
#include "../Common/Scene.h"
#include "../Common/Camera.h"
#include <vector>
#include <stdio.h>
#include <ctype.h>
#include <windows.h>
#include <winsock2.h>
#include <cstdio>
#include <io.h>
#include <iostream> 

extern int VERBOSE_MODE;
//Libraries
#pragma comment(lib,"ws2_32.lib")
#define BUF_SIZE 65535

//Definitions
WSADATA initialisation_win32; // Initialisation variable
int error; // Error variable
char* buffer = (char*)malloc(BUF_SIZE*sizeof(char)); // buffer containing sent and received data
SOCKET sockfd; // Socket ID
SOCKADDR_IN servaddr; // Informations bound to server
int phase=0; // Current phase

int main (int argc, char* argv[])
{
	cout << "Calibr Client initializating ..." << endl;

	// Creation of a scene
	Scene *scene = new Scene(1);

	// Initialisation winsock
	error=WSAStartup(MAKEWORD(2,2),&initialisation_win32);
	if (error!=0)
		cout << endl <<"Winsock error : "<< error << WSAGetLastError();
	else
		cout << endl << "WSAStartup  : OK" << endl;

	// Socket initialisation
	if ( (sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0)
	{
		perror("Socket error!");
		exit(1);
	}

	// Server informations
	servaddr.sin_family = AF_INET;
	servaddr.sin_port = htons(1219);
	char ad[16];
	cout << "Server adress?" << endl;
	cin >> ad;
	servaddr.sin_addr.s_addr = inet_addr(ad);

	// Connection to the server
	if (connect(sockfd, (struct sockaddr *) &servaddr, sizeof(servaddr)) < 0)
	{
		perror("Connect error!");
		Sleep(1000);
		exit(1);
	} 
	else
	{
		int len; // Length of the buffer
	
		int id; // Client ID
		len = recv(sockfd,buffer,BUF_SIZE,0); // Waiting for ID reception

		id=atoi(buffer); // ID conversion

		cout << endl << "Connected ... Client "<< id << endl;
		cout << "Waiting for cam init request ..." << endl;

		int c=0;

		// Main loop
		while(scene->getRunning())
		{
			len = recv(sockfd,buffer,BUF_SIZE,0); // Data reception

			// If length < 0, it means that the server has gone offline
			if (len<0)
			{
				cout << "Server offline ..." << endl;
				scene->setRunning(false);
				break;
			}

			// Processing, depending on the current phase
			switch(phase)
			{
			// Phase 0 : Initialisation of the camera(s)
			case 0:
				// According to the defined protocol, cam initialisation must begin with 0x01
				if(buffer[0]==0x01)
				{
					cout << "Initialisation cam launched ..." << endl;
					scene->launch(0); // Launching the camera rendering
					phase = 1;	// Going on next phase
					cout << "Waiting for shot requests ..." << endl;
				}
				else
				{
					cout << "Error data... received : "<< hex << buffer[0] << endl;
				}
				break;
			// Phase 1 : Initialisation of the objects
			case 1:
				// According to the defined protocol, shot requests must begin with 0x00

				if((buffer[0]==0x00))
				{
					
					cout << "Shot request received!" << endl;
					scene->setShotRequest(true);

					while(1)
					{
						Sleep(1);
						if(scene->getShotRequest()==false)
							break;
					}

					buffer[0]=0x00;
					buffer[1]=0x00;
					send(sockfd, buffer, 2, 0); 
					cout << "Shot taken!" << endl;

				}
				
				else
				{
					cout << "Error data...";
				}
				break;
			default :
				break;

			}

		}


	}

}

