#ifndef EPIPOLAR_H
#define EPIPOLAR_H
/*
 * Epipolar : this class contains a vector of fondamental matrix for epipolar computing
 */
#include "stdafx.h"
#include "CV.h"
#include "Cv32fUtils.h"
#include "Camera.h"
#include <vector>
#include "Scene.h"

using namespace std;

class Epipolar{
private :
	vector<CvMatr32f> tabEpipolar;
	int nbCam;
	vector<CvMatr32f> tabmatForNorm;


	void setTabEpipolar(vector<CvMatr32f>);

	//CvMatr32f computeFundamentalMatrix(Camera*, Camera*);
	void addEpipolarMatrix(CvMatr32f*);

	void addTab(CvMatr32f*);


public:
	// Constructor & destructor
	Epipolar();
	~Epipolar();

	// Accessors & mutators
	CvMatr32f getEpipolarMatrix(int, int);
	vector<CvMatr32f> getTabEpipolar();

	CvMatr32f getMatrixForNorm(int);
	
	void generateFundamentalMatrix(Scene);
	int getNbCam();

	
	
};


#endif
