
#include "stdafx.h"
#include  "trackEpipol.h"

using namespace std;

//the threshold is detemined after some experiences
//but can be change during the shot
double seuilRayon = 117.;

int seuilBalle;

void changeSeuil(int arg){
	seuilRayon = (float) seuilBalle;
}


void calculExisteBalle(CvMatr32f* F,CvMatr32f* E0, CvMatr32f* E1, Camera* cam1 , Camera* cam2 , bool ** tab){
	//we try every matching between two rays, and note if the threshold permit it to represent a spot
	int n1=(int) cam1->getRawPointsVector()->size();
	int n2=(int) cam2->getRawPointsVector()->size();
	CvVect32f vect0 =new float[3];
	CvVect32f vect1 =new float[3];

	bool* tableau=new bool[n1*n2];
	for (int i=0 ;i<n1 ;i++){
		for (int j=0 ;j<n2 ; j++){
		
		CvPoint p0 = (*(cam1->getRawPointsVector()))[i];
		CvPoint p1 = (*(cam2->getRawPointsVector()))[j];
		vect0[0]=(float) p0.x;
		vect0[1]=(float) p0.y;
		vect0[2]= (float) 1.;
		vect1[0]=(float) p1.x;
		vect1[1]=(float) p1.y;
		vect1[2]= (float) 1.;
		//this is the calculus of the epipolar constraint
		double res1 = scalarProduct(vect0,vect1,3,*F);
		//calculus of the norm of the vectorial product of the two guidal vectors
		CvVect32f aux1 = productMV(vect0 , *E0);
		CvVect32f aux2 = productMV(vect1, *E1);
		CvVect32f aux3 = crossProductVect(aux1 , aux2);
		double res2 = sqrt( pow(aux3[0],2)+pow(aux3[1],2)+pow(aux3[2],2));
		double res3 = res1/res2;
		//res3 is the distance between the two rays (strait line)

		//printf("res cam1 %d cam2 %d  rayons %d et %d :: res3 %e res2 %e\n",cam1->getId(),cam2->getId(), i , j , res3,res2);
		tableau[i*n2+j]=(fabs(res3) < seuilRayon );
		delete [] aux1;
		delete [] aux2;
		delete [] aux3;
		}
	}	
	delete [] vect0;
	delete [] vect1;
	*tab=tableau;
}
void afficheTableaux(bool** Tableaux,Scene* scene){
	int nbCam = scene->getNbCam();
	for (int i = 0 ; i<nbCam ;i++){
		for (int j=0 ; j< nbCam ; j++){
			if (Tableaux[i*nbCam+j]==NULL)
				continue;
			bool* tab=Tableaux[i*nbCam+j];
			printf("***\n");
			printf("tableau de cam %d x cam %d\n",i,j);
			int n1=(int) scene->getCam(i)->getRawPointsVector()->size();
			int n2=(int) scene->getCam(j)->getRawPointsVector()->size();
			printf("taille des rawvector : n1 %d , n2 %d\n",n1,n2);

			for (int i2=0 ;i2<n1 ;i2++){
				for (int j2=0 ;j2<n2 ; j2++){
					if (tab[i2*n2+j2]){
						printf("1\t");
					}else{
						printf("0\t");
					}
					
				}
				printf("\n");
			}
			printf("\n");
		}

	}
}


void trackingEpipolaire(Scene* scene){
	//number of cameras
	int nbCam = scene->getNbCam();

	bool** Tableaux;
	Tableaux= (bool**) malloc(nbCam * nbCam *sizeof(bool*));
	Epipolar* Epi=new Epipolar();
	//generation of fundamental epipolar matrix
	Epi->generateFundamentalMatrix(*scene);
	CvMatr32f F;
	CvMatr32f E0;
	CvMatr32f E1;
	
	//we build the table of matching for every couple of cameras
	for (int i = 0 ; i<nbCam ;i++){
		E0=Epi->getMatrixForNorm(i);
		for (int j=0 ; j< nbCam ; j++){
			if (i>=j){
				Tableaux[nbCam*i +j]=NULL;
				continue;
			}
			F = Epi->getEpipolarMatrix(i,j);
			E1 = Epi->getMatrixForNorm(j);
			calculExisteBalle(&F,&E0,&E1,scene->getCam(i),scene->getCam(j),Tableaux+i*nbCam+j);
		}
	}
	
	//afficheTableaux( Tableaux, scene);

	
	
	//we empty out the "PointsVector" of every cam, befor filling them
	for (int les_cam = 0 ;les_cam < scene->getNbCam() ;les_cam++){
		scene->getCam(les_cam)->getPointsVector()->clear();
	}
	
	//identifyPoints is a table of vector. each cell represent a camera. 
	//the cell #i in each vector represent a unique spot. If identifyPoints[j][i]==NULL, the camera j doesn't seen the spot
	//else IdentifyPoints[j][i] aim the CvPoint.
	vector<CvPoint * >*  identifyPoints;
	identifyPoints = (vector<CvPoint *> *) malloc(nbCam * sizeof(vector<CvPoint *>));
	for (int pt=0 ; pt<nbCam ;pt++){
		identifyPoints[pt]=vector<CvPoint*>();
	}

	//we fill identifyPoints
	//When more than 2 cam saw the same spot, This spot corresponds at a matching between every couple
	//of cameras. This is what is searched ! 
	for (int ncam1=0 ;ncam1 < nbCam ;ncam1++){
		for (int ncam2 = ncam1+1 ; ncam2 < nbCam ; ncam2++){
			bool* tab1_2 = Tableaux[ncam1 * nbCam + ncam2];
			int n1 = (int) scene->getCam(ncam1)->getRawPointsVector()->size();
			int n2 =  (int) scene->getCam(ncam2)->getRawPointsVector()->size();
			for (int np1=0 ; np1 < n1 ; np1++){
				for (int np2=0 ; np2 < n2 ; np2++){
					if (! tab1_2[np1 * n2 + np2])
						continue;
					//We find a matching between two rays, we searching is others cameras see this spot 
					tab1_2[np1 * n2 + np2]=false; //we remove this matching, to avoid to peruse this match again
					//camsrayons keep the cameras and the rays that is the same spot whith "ncam1" and the ray "np1"
					vector<CamRayon> camsrayons;
					camsrayons.push_back(CamRayon(ncam2,np2));
					//we looking for an other camera that see this spot
					for (int suivcam = ncam2+1 ; suivcam < nbCam; suivcam++){
						bool* suivtab = Tableaux[ncam1 * nbCam + suivcam];
						int n_cour = (int) scene->getCam(suivcam)->getRawPointsVector()->size();
						for (int np_cour = 0 ; np_cour < n_cour ; np_cour++){
							if (suivtab[np1 * n_cour + np_cour]){
								//the camera "suivcam" and ray "np_cour" can represent the same spot
								//we verify if there is a matching between "np_cour" and the rays held in camsrayons.
								bool correspondance = true ; 
								vector<bool * > anuliser;
								for (vector<CamRayon>::iterator it=camsrayons.begin() ; it!=camsrayons.end() ; it++){
									bool* veriftab = Tableaux[it->getCam() * nbCam + suivcam ];
									anuliser.push_back( &(veriftab[it->getRayon() * n_cour + np_cour]) );
									correspondance = correspondance && veriftab[it->getRayon() * n_cour + np_cour];
								}
								if (correspondance){//if this represent the same spot, 
									//we remote theses matching (vector "anuliser")
									//and keep this cam and ray in camsrayons
									camsrayons.push_back(CamRayon(suivcam , np_cour));
					
									suivtab[np1 * n_cour + np_cour]=false; 
									if (! anuliser.empty()){
										for (vector<bool *>::iterator itnu=anuliser.begin() ; itnu!=anuliser.end() ; itnu++){
											*((bool*)(*itnu))=false;
										}
									anuliser.clear();
									}
									break; //change of camera
								}
								anuliser.clear();
							}//we look for if another ray correspond at this spot !
						}
					}
					//finaly we find a spot and we know witch camera see it! ( "ncam1" and this taht are in "camsrayons")

					vector<CamRayon>::iterator itRayon = camsrayons.begin();
					for (int lescam = 0 ; lescam < scene->getNbCam() ;  lescam++ ){ 
						if (itRayon!=camsrayons.end() && lescam== itRayon->getCam()){
							identifyPoints[lescam].push_back(  &((*(scene->getCam(lescam)->getRawPointsVector()))[itRayon->getRayon()])   );
							  //push the pointeur of CvPoint
							  itRayon++;
						  }else{
							  if(lescam==ncam1){
							  identifyPoints[lescam].push_back(  &((*(scene->getCam(ncam1)->getRawPointsVector()))[ np1 ])   );
							  }else{
								  identifyPoints[lescam].push_back(NULL);
								  //push NULL because this camera doesn't see this spot
							  }
						  }
							  
					}

					camsrayons.clear();
				}//look for another spot !				
			}
		}
	}
	//after this process, it could have more spots than it exist in the scene.
	//this process aim to remove some of spots
	//if a ray define two spots (or more), there is two ray (or more), one for each spot. if one of these rays define only a spot
	//therefore this is the second spot that dosn't exist, so we remove it
	//this preocess dosn't work if all the rays define two spots or more...
	for (int nwebcam=0 ; nwebcam<nbCam ;nwebcam++){
		for (int pt=0 ; pt< (int) identifyPoints[0].size(); pt++){
			if (identifyPoints[nwebcam][pt] == NULL )
				continue;
			//we find a point 
			bool present2fois = false;
			int pt2=0;
			//look for if this point is use several time to define the spots
			for (vector<CvPoint*>::iterator itpoint=identifyPoints[nwebcam].begin() ; itpoint != identifyPoints[nwebcam].end() ; itpoint++,pt2++){
				if (pt2 == pt)
					continue;
				if ( *itpoint == identifyPoints[nwebcam][pt]){
					present2fois=true;
					break;
				}
			}
			if (present2fois){//look for a cam that define the spot with the point previously found
				bool point2trouve=false;
				for (int cam_cour=0 ; cam_cour<nbCam ; cam_cour++){
					if(cam_cour == nwebcam)
						continue;
					if(identifyPoints[cam_cour][pt]==NULL)
						continue;
					//the camera id found
					//we look if the point is use several time , if not we can remove a spot;
					int pt3=0;
					for (vector<CvPoint*>::iterator itpoint2=identifyPoints[cam_cour].begin() ; itpoint2 != identifyPoints[cam_cour].end() ; itpoint2++,pt3++){
						if (pt3==pt)
							continue;
						if ( *itpoint2 == identifyPoints[cam_cour][pt]){//on en a trouv un deuxieme
							point2trouve = true;
							break;
						}
					}
					if (!point2trouve){//this point is not used several time-> we can remove the spot "pt2"
						for (int CamZ=0 ; CamZ < nbCam ; CamZ++){
							identifyPoints[CamZ].erase( identifyPoints[CamZ].begin() + pt2);
							
						}
						pt--;
						break;
					}
					
					point2trouve=false;
				}
			}
		}
	}

//The finals spots are in identifyPoints, we copy out tese result in the "PointVector" of cameras
				

	for(int cams=0 ; cams < nbCam ;cams++){
	
		for(vector<CvPoint*>::iterator it= identifyPoints[cams].begin(); 
			it!=identifyPoints[cams].end() ; 
			it++){
				if (*it == NULL){
					scene->getCam(cams)->getPointsVector()->push_back(cvPoint(-1,-1));
				}else{
					scene->getCam(cams)->getPointsVector()->push_back(*((CvPoint*)(*it)));
				}
		}
	}

	free(identifyPoints);

}